Subject: RE: LDP - question about partially setup LSPs

From: Olle Pers <[email-masked]>
Date: Wed, 31 Jan 2001 11:02:11 +0100

*  
*  Let us assume that the middle router does aggregation !
*  
*  Now the packet enters the middle router labelled 
*  and he cannot have a direct outgoing 
*  labelled path as he has not got labels 
*  for the summary but only for the 
*  specific destinations for forwarding the packet.
*  
That is a different problem. With basic LDP, all routers 
should have the same IGP routing table. 

*  Therefore whenever he receives a labelled packet 
*  and does not have any outgoing label for that he 
*  has to remove the label and do a normal layer-3
*  lookup in his routing table.
*  
Yes that would be a third option. (And if this layer-3 
lookup identifies an outgoing interface, should the 
packet be sent out on that interface, or should it be 
dropped anyway?)    

But back to the original question: 

Section 3.22 of RFC 3031 applies when the incoming label does not 
map to an NHLFE. This is not necessarily the same as having no 
outgoing label.  

In David's example, the incoming label would map to an NHLFE containing 
the next hop "router C" and the operation "pop the label stack". 
When B later receives the label mapping from C, that NHLFE will 
be changed to contain a "replace label" operation. 

Olle

---

From: David Charlap <[email-masked]>
Date: Wed, 31 Jan 2001 10:35:25 -0500

Olle Pers wrote:
>>
>> Let us assume that the middle router does aggregation !
>>
>>  Now the packet enters the middle router labelled and he cannot have
>> a direct outgoing labelled path as he has not got labels for the
>> summary but only for the specific destinations for forwarding the
>> packet.
>
> That is a different problem. With basic LDP, all routers should have
> the same IGP routing table.

They should all have the same IGP routing table.  But they may not all
have the same EGP routing table.

Router B will always know how to get to C.  But it may not know all of
the (potentially millions) of prefixes that are reachable through C.

>> Therefore whenever he receives a labelled packet and does not have
>> any outgoing label for that he has to remove the label and do a
>> normal layer-3 lookup in his routing table.
>
> Yes that would be a third option. (And if this layer-3 lookup
> identifies an outgoing interface, should the packet be sent out on
> that interface, or should it be dropped anyway?)

Well, that is the entire question.  If the layer-3 lookup doesn't
identify an outgoing interface (the L3 address may be exterior to the
MPLS network and unknown to router B), then it has no choice but to drop
the packet.  Similarly if the packet is not using an L3 protocol that
router B understands.

> In David's example, the incoming label would map to an NHLFE
> containing the next hop "router C" and the operation "pop the label
> stack".

Is this a given?  Does the RFC state that a router independantly sending
out a label mapping without having received one yet should allocate an
NHLFE for popping the label?

> be changed to contain a "replace label" operation.

This much is certain.  To ignore a received label mapping would be
broken (in the absence of some kind of local policy, of course.)

-- David